//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>GMavromanolakis
#ifndef Average_HH
#define Average_HH

#include <iostream>
#include <cmath>


using namespace std;

//////////////////////////////////////////////////////////////////////////////

/// Utility class
/** 
*/
class Average
{
   public:

//............................................................................         
   Average(): _n(0), _sum(0.), _sumOfSquares(0.)
   {}
//............................................................................         
   void reset() 
   {
      _n=0;
      _sum=0.0;
      _sumOfSquares=0.0;
   }
//...........................................................................   
   void add(double val)
   {
      _n++;
      _sum+=val;
      _sumOfSquares+=val*val;
   }
//............................................................................         
   void operator+=(double val) 
   {  add(val);
   }
//............................................................................      
   double average() const
   {
      if(_n>0)
      {
      	 return (1.*_sum)/_n;
      }
      return 0.;
   }
//............................................................................         
   double sigma() const
   {
      if(_n<=1) return -1.;
      return sqrt(1.*(_n*_sumOfSquares-_sum*_sum)/(_n*(_n-1)));
   }
//............................................................................         
   double sum() const
   {
      return _sum;
   }
//............................................................................         


   private:

   int _n;
   double _sum;
   double _sumOfSquares;

};

#endif
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
